<?php
namespace Bushelpowered\Api\Iam\Access\Manage\V1;

use \Bushelpowered\Api\Iam\Access\Manage\V1\Request\AddSubjectGroupMembersRequest;
use \Bushelpowered\Api\Iam\Access\Manage\V1\Response\AddSubjectGroupMembersResponse;
use \Bushelpowered\Api\Common\BadRequest;
use \Bushelpowered\Api\Common\NotAuthenticated;
use \Bushelpowered\Api\Common\NotAuthorized;
use \Bushelpowered\Api\Common\NotFound;
use \Bidl\Php\Core\Builtins\UnknownError;

class AddSubjectGroupMembers 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    public function call(AddSubjectGroupMembersRequest $request, $headers): AddSubjectGroupMembersResponse | BadRequest | NotAuthenticated | NotAuthorized | NotFound | UnknownError
    {
         return $this->client->call('api/iam/access/manage/v1/AddSubjectGroupMembers', $request, new AddSubjectGroupMembersResponseWrapper(), $headers)->response;
    }
}

class AddSubjectGroupMembersResponseWrapper implements \Bidl\Php\Core\BIDlResponse {

    /** @var AddSubjectGroupMembersResponse | BadRequest | NotAuthenticated | NotAuthorized | NotFound | UnknownError */
    public $response;

    public function __construct()
    {
        $this->mapper = new \JsonMapper();
    }
    
    public function fromJson($data) 
    {
        switch($data->type) {
          case 'api.iam.access.manage.v1#AddSubjectGroupMembersSuccess':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Iam\Access\Manage\V1\Response\AddSubjectGroupMembersResponse::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#BadRequest':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\BadRequest::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#NotAuthenticated':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthenticated::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#NotAuthorized':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthorized::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#NotFound':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotFound::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
           default: 
             $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
        }
    }
}