<?php
namespace Bushelpowered\Api\Iam\Access\Manage\V1;

use \Bushelpowered\Api\Iam\Access\Manage\V1\Request\UpdateSubjectGroupRequest;
use \Bushelpowered\Api\Iam\Access\Manage\V1\Response\SubjectGroupResponse;
use \Bushelpowered\Api\Common\BadRequest;
use \Bushelpowered\Api\Common\ConstraintViolation;
use \Bushelpowered\Api\Common\NotAuthenticated;
use \Bushelpowered\Api\Common\NotAuthorized;
use \Bidl\Php\Core\Builtins\UnknownError;

class UpdateSubjectGroup 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    public function call(UpdateSubjectGroupRequest $request, $headers): SubjectGroupResponse | BadRequest | ConstraintViolation | NotAuthenticated | NotAuthorized | UnknownError
    {
         return $this->client->call('api/iam/access/manage/v1/UpdateSubjectGroup', $request, new UpdateSubjectGroupResponseWrapper(), $headers)->response;
    }
}

class UpdateSubjectGroupResponseWrapper implements \Bidl\Php\Core\BIDlResponse {

    /** @var SubjectGroupResponse | BadRequest | ConstraintViolation | NotAuthenticated | NotAuthorized | UnknownError */
    public $response;

    public function __construct()
    {
        $this->mapper = new \JsonMapper();
    }
    
    public function fromJson($data) 
    {
        switch($data->type) {
          case 'api.iam.access.manage.v1#UpdateSubjectGroupSuccess':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Iam\Access\Manage\V1\Response\SubjectGroupResponse::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#BadRequest':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\BadRequest::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#ConstraintViolation':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\ConstraintViolation::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#NotAuthenticated':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthenticated::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#NotAuthorized':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthorized::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
           default: 
             $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
        }
    }
}