<?php
namespace Bushelpowered\Api\Payments\V1\Model;
        
class PaymentStandard implements Api\Common\Event\StandardRecord, Api\Common\HasSourceTimestamps, Api\Common\HasTimestamps
{
    public string $tenantId;
    public string $datasourceId;
    public string $integrationId;
    public string $sourceId;
    public ?string $sourceAccountId = null;
    public ?string $accountId = null;
    public ?string $accountIntegrationId = null;
    public ?string $sourceLocationId = null;
    public ?string $locationId = null;
    public ?string $locationIntegrationId = null;
    public ?string $sourceCommodityId = null;
    public ?string $commodityId = null;
    public ?string $commodityIntegrationId = null;
    public string $entityRevisionId;
    /** @var string[]|null $sourceSettlementIds */
    public ?array $sourceSettlementIds = null;
    /** @var string[]|null $sourceInvoiceIds */
    public ?array $sourceInvoiceIds = null;
    public ?string $sourceDisplayId = null;
    public float $sourcePaymentAmount;
    public string $sourcePaymentType;
    public string $sourceStatus;
    public ?int $sourcePaymentDate = null;
    public ?string $sourceCurrency = null;
    public ?string $sourceComments = null;
    public string $id;
    public int $updatedAt;
    public int $createdAt;
    public ?int $deletedAt = null;
    public int $sourceCreatedAt;
    public int $sourceUpdatedAt;
    public ?int $sourceDeletedAt = null;

    /**
     * @param  null  $tenantId
     * @param  null  $datasourceId
     * @param  null  $integrationId
     * @param  null  $sourceId
     * @param  null  $sourceAccountId
     * @param  null  $accountId
     * @param  null  $accountIntegrationId
     * @param  null  $sourceLocationId
     * @param  null  $locationId
     * @param  null  $locationIntegrationId
     * @param  null  $sourceCommodityId
     * @param  null  $commodityId
     * @param  null  $commodityIntegrationId
     * @param  null  $entityRevisionId
     * @param  string[]|null  $sourceSettlementIds
     * @param  string[]|null  $sourceInvoiceIds
     * @param  null  $sourceDisplayId
     * @param  null  $sourcePaymentAmount
     * @param  null  $sourcePaymentType
     * @param  null  $sourceStatus
     * @param  null  $sourcePaymentDate
     * @param  null  $sourceCurrency
     * @param  null  $sourceComments
     * @param  null  $id
     * @param  null  $updatedAt
     * @param  null  $createdAt
     * @param  null  $deletedAt
     * @param  null  $sourceCreatedAt
     * @param  null  $sourceUpdatedAt
     * @param  null  $sourceDeletedAt
     */
    public function __construct(string $tenantId, string $datasourceId, string $integrationId, string $sourceId, ?string $sourceAccountId, ?string $accountId, ?string $accountIntegrationId, ?string $sourceLocationId, ?string $locationId, ?string $locationIntegrationId, ?string $sourceCommodityId, ?string $commodityId, ?string $commodityIntegrationId, string $entityRevisionId, ?array $sourceSettlementIds, ?array $sourceInvoiceIds, ?string $sourceDisplayId, float $sourcePaymentAmount, string $sourcePaymentType, string $sourceStatus, ?int $sourcePaymentDate, ?string $sourceCurrency, ?string $sourceComments, string $id, int $updatedAt, int $createdAt, ?int $deletedAt, int $sourceCreatedAt, int $sourceUpdatedAt, ?int $sourceDeletedAt)
    {
        $this->tenantId = $tenantId;
        $this->datasourceId = $datasourceId;
        $this->integrationId = $integrationId;
        $this->sourceId = $sourceId;
        $this->sourceAccountId = $sourceAccountId;
        $this->accountId = $accountId;
        $this->accountIntegrationId = $accountIntegrationId;
        $this->sourceLocationId = $sourceLocationId;
        $this->locationId = $locationId;
        $this->locationIntegrationId = $locationIntegrationId;
        $this->sourceCommodityId = $sourceCommodityId;
        $this->commodityId = $commodityId;
        $this->commodityIntegrationId = $commodityIntegrationId;
        $this->entityRevisionId = $entityRevisionId;
        $this->sourceSettlementIds = $sourceSettlementIds;
        $this->sourceInvoiceIds = $sourceInvoiceIds;
        $this->sourceDisplayId = $sourceDisplayId;
        $this->sourcePaymentAmount = $sourcePaymentAmount;
        $this->sourcePaymentType = $sourcePaymentType;
        $this->sourceStatus = $sourceStatus;
        $this->sourcePaymentDate = $sourcePaymentDate;
        $this->sourceCurrency = $sourceCurrency;
        $this->sourceComments = $sourceComments;
        $this->id = $id;
        $this->updatedAt = $updatedAt;
        $this->createdAt = $createdAt;
        $this->deletedAt = $deletedAt;
        $this->sourceCreatedAt = $sourceCreatedAt;
        $this->sourceUpdatedAt = $sourceUpdatedAt;
        $this->sourceDeletedAt = $sourceDeletedAt;
    }
    
    public function getTenantId(): string
    {
        return $this->tenantId;
    }
    public function getDatasourceId(): string
    {
        return $this->datasourceId;
    }
    public function getIntegrationId(): string
    {
        return $this->integrationId;
    }
    public function getSourceId(): string
    {
        return $this->sourceId;
    }
    public function getAccountId(): ?string
    {
        return $this->accountId;
    }
    public function getLocationId(): ?string
    {
        return $this->locationId;
    }
    public function getId(): string
    {
        return $this->id;
    }
    public function getUpdatedAt(): int
    {
        return $this->updatedAt;
    }
    public function getCreatedAt(): int
    {
        return $this->createdAt;
    }
    public function getDeletedAt(): ?int
    {
        return $this->deletedAt;
    }
    public function getSourceCreatedAt(): int
    {
        return $this->sourceCreatedAt;
    }
    public function getSourceUpdatedAt(): int
    {
        return $this->sourceUpdatedAt;
    }
    public function getSourceDeletedAt(): ?int
    {
        return $this->sourceDeletedAt;
    }
}