<?php

namespace Bushelpowered\Api\Platform\Authorization\Event;

class AccountIdentifiersVersions
{
    public string $type;
    private $data;
    private \JsonMapper $mapper;

    private $types = [
        version1 => '\Bushelpowered\Api\Platform\Authorization\V1\Event\AccountIdentifiersRaw',
    ];

    private function __constructor($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function Version1(\Bushelpowered\Api\Platform\Authorization\V1\Event\AccountIdentifiersRaw $data): AccountIdentifiersVersions
    {
        return AccountIdentifiersVersions(version1, $data);
    }

    public function getData() {
        $className = $this->types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    