<?php
namespace Bushelpowered\Api\Platform\Branding\V1\Request;
        
class CreateMobileBuildRequest 
{
    /** @var string[] $flavorIds */
    public array $flavorIds;
    public \Bushelpowered\Api\Platform\Branding\V1\Request\BuildPlatform $platform;
    public \Bushelpowered\Api\Platform\Branding\V1\Request\BuildType $buildType;
    /** @var string[] $emails */
    public array $emails;
    public ?string $androidBranch = null;
    public \Bushelpowered\Api\Platform\Branding\V1\Request\BuildType $androidBuildType = null;
    public ?string $iosBranch = null;
    public \Bushelpowered\Api\Platform\Branding\V1\Request\IosLane $lane = null;

    /**
     * @param  string[]  $flavorIds
     * @param  null  $platform
     * @param  null  $buildType
     * @param  string[]  $emails
     * @param  null  $androidBranch
     * @param  null  $androidBuildType
     * @param  null  $iosBranch
     * @param  null  $lane
     */
    public function __construct(array $flavorIds, \Bushelpowered\Api\Platform\Branding\V1\Request\BuildPlatform $platform, \Bushelpowered\Api\Platform\Branding\V1\Request\BuildType $buildType, array $emails, ?string $androidBranch, \Bushelpowered\Api\Platform\Branding\V1\Request\BuildType $androidBuildType, ?string $iosBranch, \Bushelpowered\Api\Platform\Branding\V1\Request\IosLane $lane)
    {
        $this->flavorIds = $flavorIds;
        $this->platform = $platform;
        $this->buildType = $buildType;
        $this->emails = $emails;
        $this->androidBranch = $androidBranch;
        $this->androidBuildType = $androidBuildType;
        $this->iosBranch = $iosBranch;
        $this->lane = $lane;
    }
    

}