<?php
namespace Bushelpowered\Api\Platform\Tenant\V1;

use \Bushelpowered\Api\Platform\Tenant\V1\Request\GetAllAccountsRequest;
use \Bushelpowered\Api\Platform\Tenant\V1\Response\AccountListResponse;
use \Bushelpowered\Api\Common\BadRequest;
use \Bushelpowered\Api\Common\NotAuthenticated;
use \Bushelpowered\Api\Common\NotAuthorized;
use \Bidl\Php\Core\Builtins\UnknownError;

class GetAllAccounts 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    public function call(GetAllAccountsRequest $request, $headers): AccountListResponse | BadRequest | NotAuthenticated | NotAuthorized | UnknownError
    {
         return $this->client->call('api/platform/tenant/v1/GetAllAccounts', $request, new GetAllAccountsResponseWrapper(), $headers)->response;
    }
}

class GetAllAccountsResponseWrapper implements \Bidl\Php\Core\BIDlResponse {

    /** @var AccountListResponse | BadRequest | NotAuthenticated | NotAuthorized | UnknownError */
    public $response;

    public function __construct()
    {
        $this->mapper = new \JsonMapper();
    }
    
    public function fromJson($data) 
    {
        switch($data->type) {
          case 'api.platform.tenant.v1#GetAllAccountsSuccess':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Platform\Tenant\V1\Response\AccountListResponse::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#BadRequest':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\BadRequest::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#NotAuthenticated':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthenticated::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#NotAuthorized':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthorized::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
           default: 
             $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
        }
    }
}