<?php
namespace Bushelpowered\Api\Trade\Futures\V1\Response;
        
class FuturesOverrideResponse implements Api\Common\HasCreatedAtTimestamp, Api\Common\HasUpdatedAtTimestamp
{
    public string $id;
    public string $companyId;
    public string $name;
    public ?string $displayName = null;
    public int $createdAt;
    public int $updatedAt;

    /**
     * @param  null  $id
     * @param  null  $companyId
     * @param  null  $name
     * @param  null  $displayName
     * @param  null  $createdAt
     * @param  null  $updatedAt
     */
    public function __construct(string $id, string $companyId, string $name, ?string $displayName, int $createdAt, int $updatedAt)
    {
        $this->id = $id;
        $this->companyId = $companyId;
        $this->name = $name;
        $this->displayName = $displayName;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
    }
    
    public function getCreatedAt(): int
    {
        return $this->createdAt;
    }
    public function getUpdatedAt(): int
    {
        return $this->updatedAt;
    }
}