<?php
namespace Bushelpowered\Api\Trade\Offers\V1\Request;
        
class CreateOrderFilledRequest 
{
    public int $quantity;
    public float $price;
    public float $basisPrice;
    public float $futuresPrice;
    public ?string $comments = null;
    public int $accountId;
    public string $erpAccountId;
    public string $erpCommodityId;
    public string $erpLocationId;
    public int $orderCreatedAt;
    public int $expiresAt;
    public bool $forceFill;
    public bool $careOrder;
    public string $contractSymbol;
    public int $pricingType;
    public string $unitOfMeasure;
    public string $shortInstrumentGroupName;
    public string $commodityName;
    public string $locationName;
    public string $exchangeAbbreviation;
    public string $futuresSymbol;
    public int $deliveryStart;
    public int $deliveryEnd;
    public string $chainOrderId;

    /**
     * @param  null  $quantity
     * @param  null  $price
     * @param  null  $basisPrice
     * @param  null  $futuresPrice
     * @param  null  $comments
     * @param  null  $accountId
     * @param  null  $erpAccountId
     * @param  null  $erpCommodityId
     * @param  null  $erpLocationId
     * @param  null  $orderCreatedAt
     * @param  null  $expiresAt
     * @param  null  $forceFill
     * @param  null  $careOrder
     * @param  null  $contractSymbol
     * @param  null  $pricingType
     * @param  null  $unitOfMeasure
     * @param  null  $shortInstrumentGroupName
     * @param  null  $commodityName
     * @param  null  $locationName
     * @param  null  $exchangeAbbreviation
     * @param  null  $futuresSymbol
     * @param  null  $deliveryStart
     * @param  null  $deliveryEnd
     * @param  null  $chainOrderId
     */
    public function __construct(int $quantity, float $price, float $basisPrice, float $futuresPrice, ?string $comments, int $accountId, string $erpAccountId, string $erpCommodityId, string $erpLocationId, int $orderCreatedAt, int $expiresAt, bool $forceFill, bool $careOrder, string $contractSymbol, int $pricingType, string $unitOfMeasure, string $shortInstrumentGroupName, string $commodityName, string $locationName, string $exchangeAbbreviation, string $futuresSymbol, int $deliveryStart, int $deliveryEnd, string $chainOrderId)
    {
        $this->quantity = $quantity;
        $this->price = $price;
        $this->basisPrice = $basisPrice;
        $this->futuresPrice = $futuresPrice;
        $this->comments = $comments;
        $this->accountId = $accountId;
        $this->erpAccountId = $erpAccountId;
        $this->erpCommodityId = $erpCommodityId;
        $this->erpLocationId = $erpLocationId;
        $this->orderCreatedAt = $orderCreatedAt;
        $this->expiresAt = $expiresAt;
        $this->forceFill = $forceFill;
        $this->careOrder = $careOrder;
        $this->contractSymbol = $contractSymbol;
        $this->pricingType = $pricingType;
        $this->unitOfMeasure = $unitOfMeasure;
        $this->shortInstrumentGroupName = $shortInstrumentGroupName;
        $this->commodityName = $commodityName;
        $this->locationName = $locationName;
        $this->exchangeAbbreviation = $exchangeAbbreviation;
        $this->futuresSymbol = $futuresSymbol;
        $this->deliveryStart = $deliveryStart;
        $this->deliveryEnd = $deliveryEnd;
        $this->chainOrderId = $chainOrderId;
    }
    

}